--
-- UniaAres Hydopack
-- Autor/Author: Dawider(R)
-- Data/Date: 4.08.2013
-- 

UniaAresHP = {};

function UniaAresHP.prerequisitesPresent(specializations)
	return true;
end;

function UniaAresHP:load(xmlFile)

	local animacja1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.animacja1#index"));
	if animacja1 ~= nil then
		self.animacja1 = animacja1;
	end;
	
	local animacja2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.animacja2#index"));
	if animacja2 ~= nil then
		self.animacja2 = animacja2;
	end;	


	
end;

function UniaAresHP:delete()
end;

function UniaAresHP:keyEvent(unicode, sym, modifier, isDown)
end;
	
function UniaAresHP:update(dt)

        local nearestDistance = 1.5;
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);


		local px, py, pz = getWorldTranslation(self.animacja1); 
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);	
		if distance < nearestDistance then
			self.przyanimacji1 = true; 
		else
			self.przyanimacji1 = false; 
		end;

		local ax, ay, az = getWorldTranslation(self.animacja2); 
		local distance = Utils.vector3Length(ax-vx, ay-vy, az-vz);	
		if distance < nearestDistance then
			self.przyanimacji2 = true; 
		else
			self.przyanimacji2 = false; 
		end;
	
	
	
	
	if self.przyanimacji1 or self.isEntered then
		if InputBinding.hasEvent(InputBinding.animacja1) then
			if self.animationParts[1].clipEndTime then
				self:setAnimationTime(1, self.animationParts[1].offSet);
			elseif self.animationParts[1].clipStartTime then
				self:setAnimationTime(1, self.animationParts[1].animDuration);
			end;
		end;
	end;

	if self.przyanimacji2 or self.isEntered then
		if InputBinding.hasEvent(InputBinding.animacja2) then
			if self.animationParts[2].clipEndTime then
				self:setAnimationTime(2, self.animationParts[2].offSet);
			elseif self.animationParts[2].clipStartTime then
				self:setAnimationTime(2, self.animationParts[2].animDuration);
			end;
		end;
	end;

	if self:getIsActiveForInput(false) then
	 	if InputBinding.isPressed(InputBinding.animacja3gora) then
               self:setAnimationTime(3, self.animationParts[3].currentPosition+(self.animationParts[3].offSet+dt), false);
           elseif InputBinding.isPressed(InputBinding.animacja3dol) then
               self:setAnimationTime(3, self.animationParts[3].currentPosition-(self.animationParts[3].offSet+dt), false);
        end;
    end;
	

	
	if self.przyanimacji1 then
		if self.animationParts[1].clipStartTime then
			g_currentMission:addExtraPrintText(string.format("%s: Rozloz", InputBinding.getKeyNamesOfDigitalAction(InputBinding.animacja1)));
 		else
			g_currentMission:addExtraPrintText(string.format("%s: Zloz", InputBinding.getKeyNamesOfDigitalAction(InputBinding.animacja1)));
		end;
 	end;

	if self.przyanimacji2 then
		if self.animationParts[2].clipStartTime then
			g_currentMission:addExtraPrintText(string.format("%s: Rozloz", InputBinding.getKeyNamesOfDigitalAction(InputBinding.animacja2)));
 		else
			g_currentMission:addExtraPrintText(string.format("%s: Zloz", InputBinding.getKeyNamesOfDigitalAction(InputBinding.animacja2)));
		end;
 	end;
	
end;	

function UniaAresHP:mouseEvent(posX, posY, isDown, isUp, button)
end;

function UniaAresHP:validateAttacherJoint(implement, jointDesc, dt) 
	return true; 
end; 

function UniaAresHP:draw()
end;